import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class BubblePopper extends JFrame implements Runnable, MouseListener, MouseMotionListener, KeyListener
{
    Container con = getContentPane();
    Thread t = new Thread(this);
    int balls = 5, l = 0, colorScheme = 0, mouseX = 0, mouseY = 0;
    double screenX = 50, screenY = 50, screenX1 = 450, screenY1 = 450, r, score = 0, multi = 0;
    double[][] v = new double[1000][6];
    int[] prices = {1,2,4,8,16,32,64,128}, amount = {0,0,0,0,0,0,0,0};
    int[][] colors = {{0,31,0},{0,63,0},{0,127,0},{0,255,0},{0,255,63},{0,255,127},{0,255,255},{0,0,255},{255,0,255},{255,0,0},{255,255,0},{255,255,255}};
    String[] objects = {"Score Multiplier + 0.1","Larger Bubbles","+ 1 Score on Pop","Toggle Colors","+ 4 Score on Pop","Score Multiplier + 1","+ 16 Score on Pop","More Bubbles"};
    public BubblePopper ()
    {
        addMouseListener(this);
        addKeyListener(this);
        addMouseMotionListener(this);
        con.setLayout(new FlowLayout());
        if(l == 0){
            for(int q = 0; q < 5; q++){
                v[q][0]=((Math.random()-1)*245)+300;
                v[q][1]=((Math.random()-1)*245)+300;
                r = Math.random()*50 + 3;
                v[q][2]=r;
                v[q][3]=r;
                v[q][4]=(Math.random()/5);
                v[q][5]=(Math.random()/5);
            }
            l++;
        }
        //multi = ((0.01 * amount[0]) + (0.05 * amount[1]) + (0.2 * amount[2]) + (0.5 * amount[3]) + (1 * amount[4]) + (5 * amount[5]) + (10 * amount[6]) + (50 * amount[7]));
        t.start();
        setDefaultCloseOperation(EXIT_ON_CLOSE);
    }

    public void keyPressed(KeyEvent e) {

    }

    public void keyReleased(KeyEvent e) {

    }

    public void keyTyped(KeyEvent e) {

    }

    public void mousePressed(MouseEvent e) {

    }

    public void mouseReleased(MouseEvent e) {

    }

    public void mouseDragged(MouseEvent e) {

        for(int p = 0; p < balls; p++){
            if((e.getX() > v[p][0]) && (e.getX() < v[p][0] + v[p][2]) && (e.getY() > v[p][1]) && (e.getY() < v[p][1] + v[p][3])){
                score += (Math.abs(v[p][4])+Math.abs(v[p][5]))*multi*100/v[p][2] + 1 + amount[2] + 4*amount[4] + 16*amount[6];
                v[p][0]=((Math.random()-1)*245)+300;
                v[p][1]=((Math.random()-1)*245)+300;
                r = Math.random()*50 + 3 + amount[1];
                v[p][2]=r;
                v[p][3]=r;
                v[p][4]=(Math.random()/5);
                v[p][5]=(Math.random()/5);
            }
        }

    }

    public void mouseEntered(MouseEvent e) {

    }

    public void mouseMoved(MouseEvent e) {
        mouseX = e.getX();
        mouseY = e.getY();

    }

    public void mouseExited(MouseEvent e) {

    }

    public void mouseClicked(MouseEvent e) {
        for(int p = 0; p < balls; p++){
            if((e.getX() > v[p][0]) && (e.getX() < v[p][0] + v[p][2]) && (e.getY() > v[p][1]) && (e.getY() < v[p][1] + v[p][3])){
                score += (Math.abs(v[p][4])+Math.abs(v[p][5]))*multi*100/v[p][2] + 1 + amount[2] + 4*amount[4] + 16*amount[6];
                v[p][0]=((Math.random()-1)*245)+300;
                v[p][1]=((Math.random()-1)*245)+300;
                r = Math.random()*50 + 3 + amount[1];
                v[p][2]=r;
                v[p][3]=r;
                v[p][4]=(Math.random()/5);
                v[p][5]=(Math.random()/5);
            }
        }
        for(int box4 = 0; box4 < 8; box4++){
            if((e.getX() > screenX1) && (e.getX() < screenX1 + 150) && (e.getY() > screenY + (50*box4)) && (e.getY() < screenY +50+(50*box4))){
                if(prices[box4]<=(int)score){
                    score = score - prices[box4];
                    amount[box4]++; 

                    if(box4 == 7){
                        balls=5+amount[7];
                        v[4+amount[7]][0]=((Math.random()-1)*245)+300;
                        v[4+amount[7]][1]=((Math.random()-1)*245)+300;
                        r = Math.random()*50 + 3 + amount[1];
                        v[4+amount[7]][2]=r;
                        v[4+amount[7]][3]=r;
                        v[4+amount[7]][4]=(Math.random()/5);
                        v[4+amount[7]][5]=(Math.random()/5);
                    }
                    if(box4 == 0){
                        multi += 0.1;
                        prices[box4] = (int)(prices[box4] + Math.pow(box4+1.1,amount[box4]) - 1);
                    }else{
                        prices[box4] = (int)(prices[box4] + Math.pow(box4+1,amount[box4]) - 1); 
                    }
                    multi = (amount[0]*0.1) + amount[5];
                }
            }

        }
    }

    public void run()
    {
        try{
            while(true)
            {
                t.sleep(1);
                for(int changer = 0; changer < balls; changer++){
                    v[changer][0] += v[changer][4];
                    v[changer][1] += v[changer][5];
                    if(v[changer][0] > screenX1 - v[changer][2]){
                        v[changer][4] *= -1; 
                    }
                    if(v[changer][0] < screenX){
                        v[changer][4] *= -1; 
                    }
                    if(v[changer][1] > screenY1 - v[changer][3]){
                        v[changer][5] *= -1; 
                    }
                    if(v[changer][1] < screenY){
                        v[changer][5] *= -1; 
                    }
                }
                repaint();
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public void paint(Graphics gr)
    {
        Image i=createImage(getSize().width, getSize().height);
        Graphics2D g2 = (Graphics2D)i.getGraphics();
        g2.setColor(Color.black);
        g2.fillRect(0,0,1000,1000);
        for(int drawer = 0; drawer < balls; drawer++){
            g2.setColor(Color.white);
            if(colorScheme == 1){
                for(int nom = 0; nom < 12; nom++){
                    
                    if(((((Math.abs(v[drawer][4])+(Math.abs(v[drawer][5]))*multi*20/(v[drawer][2]-amount[1])+1) >= Math.pow(1.5,nom-3))))){
                        Color color = new Color((int)colors[nom][0],(int)colors[nom][1],(int)colors[nom][2]);
                        g2.setColor(color);
                        
                    }
                    
                    
                }
                g2.drawOval((int)v[drawer][0],(int)v[drawer][1],(int)v[drawer][2],(int)v[drawer][3]);
            }else{
                Color color = new Color(255,255,255);
                        g2.setColor(color);
                        g2.drawOval((int)v[drawer][0],(int)v[drawer][1],(int)v[drawer][2],(int)v[drawer][3]);
            }
            
        }
        g2.setColor(Color.white);
        g2.drawRect((int)(screenX),(int)(screenY),(int)(screenX1 - screenX),(int)(screenY1 - screenY));

        for(int box = 0; box < 8; box++){
            if((mouseX > screenX1) && (mouseX < screenX1 + 150) && (mouseY > screenY + (50*box)) && (mouseY < screenY +50+(50*box))){
                if(prices[box]<=(int)score){
                    Color lightGrey = new Color(191,191,191);
                    g2.setColor(lightGrey);
                }else{
                    Color Grey = new Color(127,127,127);
                    g2.setColor(Grey);
                }
                g2.fillRect((int)(screenX1),(int)(screenY)+(50*box),150,50);
            }else{
                if(prices[box]<=(int)score){
                    Color Grey = new Color(127,127,127);
                    g2.setColor(Grey);
                }else{
                    Color darkGray = new Color(63,63,63);
                    g2.setColor(darkGray);
                }
                g2.fillRect((int)(screenX1),(int)(screenY)+(50*box),150,50);
            }
        }
        g2.setColor(Color.white);
        for(int box1 = 0; box1 < 8; box1++){
            g2.drawRect((int)(screenX1),(int)(screenY)+(50*box1),150,50);
        }
        for(int box2 = 0; box2 < 8; box2++){
            g2.drawString(objects[box2],(int)(screenX1)+5,(int)(screenY)+(50*box2)+15);
            if(box2 == 3){
                if(amount[3]%2==0){
                    g2.drawString("State: Off",(int)(screenX1)+5,(int)(screenY)+(50*box2)+30);
                    colorScheme = 0;
                }else{
                    g2.drawString("State: On",(int)(screenX1)+5,(int)(screenY)+(50*box2)+30);
                    colorScheme = 1;
                }
            }else{
                g2.drawString("Amount: "+amount[box2],(int)(screenX1)+5,(int)(screenY)+(50*box2)+30);
            }
            g2.drawString("Price: "+prices[box2],(int)(screenX1)+5,(int)(screenY)+(50*box2)+45);
        }

        g2.drawString("Mouse: ("+(int)mouseX+","+(int)mouseY+")", 50, 45);
        g2.setColor(Color.green);
        g2.drawString("Score Multiplier: "+(int)(multi+1)+"."+(int)((10*(multi+1))%10), 450, 45);
        g2.setColor(Color.green);
        g2.drawString("Score: "+(int)score, 150, 45);
        g2.dispose();
        gr.drawImage(i, 0, 0, this);
    }

    public static void main(String[] args)
    {
        BubblePopper frame = new BubblePopper ();
        frame.setSize(650, 500);
        frame.setVisible(true);
    }

    public void update(Graphics g)
    {
        paint(g);
    } 
}